<* WOFF + *>
IMPLEMENTATION MODULE Afbeeldingen;
<* NOOPTIMIZE + *>

FROM Graph IMPORT SetUpdateMode, RawOutText, SetBkColor,Update, Rectangle, PutImage;
FROM StandardBitmap IMPORT DrawBitmapFile,DrawMaskFile, DrawSavedBitmap;
FROM Cars IMPORT Ferari,SportAuto,Vrachtwagen;
FROM Gegevens IMPORT SCREEN_SIZE_X, SCREEN_SIZE_Y, gAutoPositieX,gAutoPositieY;
FROM Lib IMPORT Delay;

PROCEDURE Laadbalkje(pos_x : INTEGER);    (*Made By Jonathan*)
BEGIN
SetUpdateMode(TRUE);
Rectangle(SCREEN_SIZE_X/2-100, SCREEN_SIZE_Y/2+50, VAL(CARDINAL,SCREEN_SIZE_X/2+pos_x), SCREEN_SIZE_Y/2+75,10,TRUE);
SetUpdateMode(FALSE);
END Laadbalkje;


PROCEDURE LaadAfbeeldingenIn();                 (*Samengebracht door Jonathan*) (*Afbeeldingen zelf: Made by Robin,Bart,Jonathan*)
(* Deze procedure dient om alle bitmaps op voorhand in te laden zodat er nergens in het spel wachttijden zijn, enkel bij het opstarten ervan*)	
BEGIN

	 Rectangle(SCREEN_SIZE_X/2-100, SCREEN_SIZE_Y/2+50, SCREEN_SIZE_X/2+100, SCREEN_SIZE_Y/2+75,10,FALSE); (*Leeg laadbalkje*)
	 RawOutText(SCREEN_SIZE_X/2-50, SCREEN_SIZE_Y/2, 10,"Please wait...");
	
	
	 SetUpdateMode(FALSE); (*Dit dient om nog geen afbeeldingen te beginnen tekenen, maar ze enkel een nummer toe te kennen*)
	
    	(*Auto's*)
	 Vrachtwagen.AfbeeldingAuto := DrawBitmapFile( gAutoPositieX, gAutoPositieY , "RaceBitmaps\Vrachtwagen.bmp", width, hight );
    Vrachtwagen.AfbeeldingAutoMask := DrawMaskFile( gAutoPositieX, gAutoPositieY , "RaceBitmaps\Vrachtwagen.bmp", width, hight );
    SportAuto.AfbeeldingAuto := DrawBitmapFile( gAutoPositieX, gAutoPositieY , "RaceBitmaps\SportAuto.bmp", width, hight );
    SportAuto.AfbeeldingAutoMask := DrawMaskFile( gAutoPositieX, gAutoPositieY , "RaceBitmaps\SportAuto.bmp", width, hight );
    Ferari.AfbeeldingAuto := DrawBitmapFile( gAutoPositieX, gAutoPositieY , "RaceBitmaps\Ferari.bmp", width, hight );
    Ferari.AfbeeldingAutoMask := DrawMaskFile( gAutoPositieX, gAutoPositieY , "RaceBitmaps\Ferari.bmp", width, hight );
    RijdendeAutoAfbeelding:= DrawBitmapFile( gAutoPositieX,  gAutoPositieY , "RaceBitmaps\RijdendeAuto.bmp", width, hight );
    GeparkeerdeAutoAfbeelding := DrawBitmapFile( gAutoPositieX,  gAutoPositieY , "RaceBitmaps\GeparkeerdeAuto.bmp", width, hight );
	 ExplosieAfbeelding:=DrawBitmapFile( gAutoPositieX,  gAutoPositieY , "RaceBitmaps\Explosie.bmp", width, hight );
	
	                                                                                              			Laadbalkje(-90);
	(*Objecten*)
    BoomAfbeelding := DrawBitmapFile( gAutoPositieX, gAutoPositieY , "RaceBitmaps\Boom.bmp", width, hight );
    BoomAfbeeldingMask := DrawMaskFile( gAutoPositieX, gAutoPositieY , "RaceBitmaps\Boom.bmp", width, hight );
    GastankAfbeelding := DrawBitmapFile( gAutoPositieX,gAutoPositieY , "RaceBitmaps\Gastank.bmp", width, hight );
	
	(*Tekstafbeeldingen*)                                                                         			Laadbalkje(-80);
    GameOverAfbeelding:=DrawBitmapFile( gAutoPositieX,  gAutoPositieY , "RaceBitmaps\GameOver.bmp", width, hight );	
    GameOverMask:=DrawMaskFile( gAutoPositieX,  gAutoPositieY , "RaceBitmaps\GameOver.bmp", width, hight );	
    FinishAfbeelding:=DrawBitmapFile(gAutoPositieX,  gAutoPositieY , "RaceBitmaps\Finish.bmp", width, hight);	                                                                                               			Laadbalkje(-75);
	
	(*Launcher Afbeeldingen*)
     ID0:=DrawBitmapFile(0,0,"GarageBestanden/Intro.bmp", SCREEN_SIZE_X,SCREEN_SIZE_Y);        			    Laadbalkje(-63);			
	 ID1:=DrawBitmapFile(0,0,"GarageBestanden/Home.bmp", SCREEN_SIZE_X,SCREEN_SIZE_Y);             			Laadbalkje(-50);	
	 ID2:=DrawBitmapFile(0,0,"GarageBestanden/Rc.bmp", SCREEN_SIZE_X,SCREEN_SIZE_Y);               			Laadbalkje(-38);	
	 ID3:=DrawBitmapFile(0,0,"GarageBestanden/Car.bmp",SCREEN_SIZE_X,SCREEN_SIZE_Y);               			Laadbalkje(-25);
	 ID4:=DrawBitmapFile(0,0,"GarageBestanden/Track.bmp", SCREEN_SIZE_X,SCREEN_SIZE_Y);            			Laadbalkje(-12);	
	 ID5:=DrawBitmapFile(0,0,"GarageBestanden/Tune.bmp", SCREEN_SIZE_X,SCREEN_SIZE_Y);             			Laadbalkje(0);
	 ID6:=DrawBitmapFile(0,0,"GarageBestanden/qwerty.bmp", SCREEN_SIZE_X,SCREEN_SIZE_Y);           			Laadbalkje(12);
	 ID7:=DrawBitmapFile(0,0,"GarageBestanden/Score.bmp", SCREEN_SIZE_X,SCREEN_SIZE_Y);            			Laadbalkje(25);	
	 ID10:=DrawBitmapFile(0,0,"GarageBestanden/Save.bmp", SCREEN_SIZE_X,SCREEN_SIZE_Y);            			Laadbalkje(38);
	 ID11:=DrawBitmapFile(0,0,"GarageBestanden/Load.bmp", SCREEN_SIZE_X,SCREEN_SIZE_Y);            			Laadbalkje(50);	
	 ID12:=DrawBitmapFile(100,250,"GarageBestanden/controls.bmp",SCREEN_SIZE_X/2,SCREEN_SIZE_Y/2); 			Laadbalkje(63);
	 ID13:=DrawBitmapFile(0,0,"GarageBestanden/Run.bmp",50,50);                                    			Laadbalkje(75);
	 ID14:=DrawBitmapFile(0,0,"GarageBestanden/vraagteken.bmp",50,50);                                      Laadbalkje(77);
		
	
 (*KiesAuto Afbeeldingen*)
	PijlLinks := DrawBitmapFile( 10, 10 , "GarageBestanden/PijlLinks.bmp", width, hight );
	PijlRechts := DrawBitmapFile( 10, 10 , "GarageBestanden/PijlRechts.bmp", width, hight );
	KiesAuto:= DrawBitmapFile( 10, 10 , "RaceBitmaps/KiesAuto.bmp", width, hight );
	AchtergrondAfbeelding :=DrawBitmapFile(0,0,"GarageBestanden/Car.bmp",SCREEN_SIZE_X,SCREEN_SIZE_Y);    Laadbalkje(87);
	DoneAfbeelding := DrawBitmapFile( 10, 10 , "RaceBitmaps/DoneAfbeelding.bmp", width, hight );
	
 (*KeuzeTrack Afbeeldingen*)
   PijlBoven := DrawBitmapFile( 10, 10 , "GarageBestanden/PijlBoven.bmp", width, hight );
	PijlBeneden := DrawBitmapFile( 10, 10 , "GarageBestanden/PijlBeneden.bmp", width, hight );
	
 (*Tune Afbeeldingen*)
 	MotorAfbeelding:=DrawBitmapFile(0,0,"GarageBestanden/Motor.bmp",width, hight);
	TankinhoudAfbeelding:=DrawBitmapFile(0,0,"GarageBestanden/Tankinhoud.bmp",width, hight);
	VersnellingsbakAfbeelding:=DrawBitmapFile(0,0,"GarageBestanden/Versnellingsbak.bmp",width, hight);
	RemmenAfbeelding:=DrawBitmapFile(0,0,"GarageBestanden/Remmen.bmp",width, hight);
	                                                                                              			Laadbalkje(100);
	
	SetUpdateMode(FALSE);
	
	

END LaadAfbeeldingenIn;

END Afbeeldingen.