IMPLEMENTATION MODULE KiesAuto;
<* +M2ADDTYPES *>
  <* NOOPTIMIZE + *>  (* For the Debugger *)
   FROM Cars IMPORT SportAuto, Auto, Ferari, Vrachtwagen;
   FROM Graph IMPORT Rectangle, PutImage, _clrBLACK, _clrLIGHTGREEN, Update, SetUpdateMode;
   FROM Graph IMPORT RawOutText;
   FROM Gegevens IMPORT SCREEN_SIZE_X, SCREEN_SIZE_Y,Gamer,hx,hy;
   FROM StandardBitmap IMPORT DrawNumber,DrawBitmapFile;
   FROM MsMouse IMPORT MsData,GetStatus;
   FROM Lib IMPORT Delay;
   FROM Afbeeldingen IMPORT PijlLinks, PijlRechts,AchtergrondAfbeelding, KiesAuto, DoneAfbeelding;
   FROM Launcher IMPORT Help;


VAR
    z:CARDINAL;


PROCEDURE KeuzeAuto;

VAR x:CARDINAL;
    y,width,hight: CARDINAL;

    ArrAuto : ARRAY[1..3] OF Auto;
    MousePosition: MsData;
    Arr: ARRAY[1..3] OF CARDINAL;
    Open:BOOLEAN;
BEGIN

SetUpdateMode(FALSE);
z:=1;
Open:=FALSE;


ArrAuto[1]:=SportAuto;
ArrAuto[2]:=Ferari;
ArrAuto[3]:=Vrachtwagen;

Arr[1] := DrawBitmapFile( 10, 10 , "RaceBitmaps/CarZijAanzicht.bmp", width, hight );
Arr[2] := DrawBitmapFile( 10, 10 , "RaceBitmaps/FerariZijAanzicht.bmp", width, hight );
Arr[3] := DrawBitmapFile( 10, 10 , "RaceBitmaps/VrachtwagenZijaanzicht.bmp", width, hight );


SetUpdateMode(TRUE);
Rectangle(0, 0, SCREEN_SIZE_X,SCREEN_SIZE_Y , _clrLIGHTGREEN, TRUE);
LOOP
SetUpdateMode(TRUE);

Delay(100);
GetStatus(MousePosition);
x:=MousePosition.col;
y:=MousePosition.row;





IF MousePosition.left_pressed  THEN
	IF (y>=SCREEN_SIZE_Y/10*4) AND (y<=SCREEN_SIZE_Y/10*4+60)  AND (x>=SCREEN_SIZE_X/20) AND (x<=SCREEN_SIZE_X/20+32) THEN

        z:=z-1;
    	IF z =0
      	  THEN z:=Gamer.MaxAuto;
      	END;
	
	ELSIF (y>=SCREEN_SIZE_Y/10*4) AND (y<=SCREEN_SIZE_Y/10*4+60)  AND (x>=SCREEN_SIZE_X/20*18) AND (x<=SCREEN_SIZE_X/20*18+32) THEN

        z:=z+1;
     	IF z > Gamer.MaxAuto
     	THEN z:=1;
     	END;
	
	ELSIF (y>=SCREEN_SIZE_Y/10*6) AND (y<=SCREEN_SIZE_Y/10*6+68)  AND (x>=SCREEN_SIZE_X/2-100) AND (x<=SCREEN_SIZE_X/2+109) THEN
        Gamer.GekozenAuto:=ArrAuto[z];
	Gamer.GekozenAutoNr:=z;
        RETURN;
	

	ELSIF (y>=SCREEN_SIZE_Y-76) AND (y<=SCREEN_SIZE_Y)  AND (x>=SCREEN_SIZE_X-129) AND (x<=SCREEN_SIZE_X) THEN
        Gamer.GekozenAuto:=ArrAuto[z];
	Gamer.GekozenAutoNr:=z;
        RETURN;
	
	ELSIF (x>=0) AND (x<=60) AND (y>=630) AND (y<=SCREEN_SIZE_Y) THEN
	Open:=Help(Open,'CarSlct',3,hx+10,hy,SCREEN_SIZE_X-hx,SCREEN_SIZE_Y);
	END;
	
	


END;
SetUpdateMode(FALSE);
Rectangle(0, 0, SCREEN_SIZE_X,SCREEN_SIZE_Y/10*9 , _clrLIGHTGREEN, TRUE);


PutImage(0,0,AchtergrondAfbeelding,1);

Rectangle(SCREEN_SIZE_X/20*3, SCREEN_SIZE_Y/10*3, SCREEN_SIZE_X/20*17,SCREEN_SIZE_Y/10*6 , _clrBLACK, TRUE);
PutImage(SCREEN_SIZE_X/20, SCREEN_SIZE_Y/10*4, PijlLinks, 1);
PutImage(SCREEN_SIZE_X/20*18, SCREEN_SIZE_Y/10*4, PijlRechts, 1);
PutImage(SCREEN_SIZE_X/2-100, SCREEN_SIZE_Y/10*6, KiesAuto, 1);
PutImage(SCREEN_SIZE_X-129, SCREEN_SIZE_Y-76, DoneAfbeelding, 1);

PutImage(SCREEN_SIZE_X/20*4, SCREEN_SIZE_Y/20*7, Arr[z], 0);

RawOutText(SCREEN_SIZE_X/20*3, SCREEN_SIZE_Y/10*7, 0, 'Max Snelheid: ');
DrawNumber(SCREEN_SIZE_X/20*7, SCREEN_SIZE_Y/40*29, VAL(CARDINAL,ArrAuto[z].MaxSnelheid*20.0),  _clrBLACK, _clrLIGHTGREEN);

RawOutText(SCREEN_SIZE_X/20*3, SCREEN_SIZE_Y/20*15, 0, 'Optreksnelheid: ');
DrawNumber(SCREEN_SIZE_X/20*7, SCREEN_SIZE_Y/40*31, VAL(CARDINAL,ArrAuto[z].OptrekSnelheid*20.0),  _clrBLACK, _clrLIGHTGREEN);

RawOutText(SCREEN_SIZE_X/20*3, SCREEN_SIZE_Y/20*16, 0, 'RemSnelheid: ');
DrawNumber(SCREEN_SIZE_X/20*7, SCREEN_SIZE_Y/40*33, VAL(CARDINAL,ArrAuto[z].RemSnelheid),  _clrBLACK, _clrLIGHTGREEN);

RawOutText(SCREEN_SIZE_X/20*10, SCREEN_SIZE_Y/10*7, 0, 'Max Brandstof: ');
DrawNumber(SCREEN_SIZE_X/20*14, SCREEN_SIZE_Y/40*29, VAL(CARDINAL,ArrAuto[z].MaxBrandstof),  _clrBLACK, _clrLIGHTGREEN);

RawOutText(SCREEN_SIZE_X/20*10, SCREEN_SIZE_Y/20*15, 0, 'BrandstofVerbruik: ');
DrawNumber(SCREEN_SIZE_X/20*15, SCREEN_SIZE_Y/40*31, VAL(CARDINAL,ArrAuto[z].MaxSnelheid),  _clrBLACK, _clrLIGHTGREEN);

RawOutText(SCREEN_SIZE_X/20*10, SCREEN_SIZE_Y/20*16, 0, 'Zwakte : ');
DrawNumber(SCREEN_SIZE_X/20*14, SCREEN_SIZE_Y/40*33, VAL(CARDINAL,ArrAuto[z].Zwakte),  _clrBLACK, _clrLIGHTGREEN);

RawOutText(SCREEN_SIZE_X/20*3, SCREEN_SIZE_Y/20*17, 0, 'Handrem : ');
DrawNumber(SCREEN_SIZE_X/20*7, SCREEN_SIZE_Y/40*35, VAL(CARDINAL,ArrAuto[z].Handrem),  _clrBLACK, _clrLIGHTGREEN);

RawOutText(SCREEN_SIZE_X/20*10, SCREEN_SIZE_Y/20*17, 0, 'Max Damage : ');
DrawNumber(SCREEN_SIZE_X/20*14, SCREEN_SIZE_Y/40*35, VAL(CARDINAL,ArrAuto[z].MaxDamageMeter),  _clrBLACK, _clrLIGHTGREEN);

Update();

END;

END KeuzeAuto;



END KiesAuto.

