IMPLEMENTATION MODULE Launcher;   (*Geschreven door Bart*)

  <* +M2ADDTYPES *>
  <* NOOPTIMIZE + *>  (* For the Debugger *)
  FROM IO IMPORT  RdKey, KeyPressed;
  FROM Lib IMPORT Delay;
    IMPORT FIO; (*File import*)
  FROM Graph IMPORT Rectangle,RawOutText,SetTextWindow, Disc;
  FROM Graph IMPORT SetUpdateMode,Update,SetBkColor; (* for bitmap saving *)
  FROM Str IMPORT Match,Length,Concat;
  FROM StandardBitmap IMPORT DrawSavedBitmap;
  FROM MsMouse IMPORT MsData,GetStatus;
  FROM Gegevens IMPORT SCREEN_SIZE_X,SCREEN_SIZE_Y, Gamer,Zwart,Wit,hx,hy,gLegeLijn;
  FROM Afbeeldingen IMPORT ID0, ID6, ID14,ID10;
  FROM Cars IMPORT SportAuto,Ferari, Vrachtwagen;

(*----------------------------------------------------------------*)	
PROCEDURE Help (Open:BOOLEAN;name:ARRAY OF CHAR;NbrOfRepeats,x1,y1,x2,y2:CARDINAL):BOOLEAN;
CONST   map='_Help/' ;
VAR Inh : ARRAY [1..400] OF CHAR;    (*Inhoud*)
    Floc : ARRAY [1..20] OF CHAR;    (*Floc: File Location*)
    F : FIO.File;                    (*F:File*)
	i:CARDINAL;	
BEGIN
IF Open = FALSE THEN
Concat(Floc,map,name);Concat(Floc,Floc,'.txt');
F:=FIO.Open(Floc);
FOR i:=1 TO NbrOfRepeats DO
	FIO.RdStr(F, Inh);
	RawOutText(x1,y1+20*(i-1),Zwart,Inh);
END; (*FOR*)
FIO.Close(F);
RawOutText(0,0,Wit,''); (*Clear Buffer*)
RETURN TRUE;
ELSE Rectangle(x1,y1,x2,y2,Wit,TRUE);
RETURN FALSE;
END; (*IF*)
END Help;
(*---------------------------------------------------------------*)	
PROCEDURE InladenGegevens(iloc: ARRAY OF CHAR);
VAR
SpelersFile,AutoFile:FIO.File;
SportAutoFileLoc,FerrariFileLoc,VrachtwagenFileLoc,Spelersloc:ARRAY[1..40] OF CHAR;
z: CARDINAL;

BEGIN
Concat(SportAutoFileLoc,iloc,'SportAuto.txt');
AutoFile:=FIO.Open(SportAutoFileLoc);
SportAuto.MaxSnelheid:=VAL(REAL,FIO.RdCard(AutoFile));
SportAuto.OptrekSnelheid:=VAL(REAL,FIO.RdCard(AutoFile))/100.0;;
SportAuto.RemSnelheid:= VAL(REAL,FIO.RdCard(AutoFile))/10.0;
SportAuto.MaxBrandstof:=FIO.RdCard(AutoFile);
FIO.Close(AutoFile);

Concat(FerrariFileLoc,iloc,'Ferrari.txt');
AutoFile:=FIO.Open(FerrariFileLoc);
Ferari.MaxSnelheid:= VAL(REAL,FIO.RdCard(AutoFile));
Ferari.OptrekSnelheid:=VAL(REAL,FIO.RdCard(AutoFile))/100.0;
Ferari.RemSnelheid:= VAL(REAL,FIO.RdCard(AutoFile))/10.0;
Ferari.MaxBrandstof:= FIO.RdCard(AutoFile);
FIO.Close(AutoFile);

Concat(VrachtwagenFileLoc,iloc,'Vrachtwagen.txt');
AutoFile:=FIO.Open(VrachtwagenFileLoc);
Vrachtwagen.MaxSnelheid:=VAL(REAL,FIO.RdCard(AutoFile));
Vrachtwagen.OptrekSnelheid:= VAL(REAL,FIO.RdCard(AutoFile))/100.0;
Vrachtwagen.RemSnelheid:= VAL(REAL,FIO.RdCard(AutoFile))/10.0;
Vrachtwagen.MaxBrandstof:=FIO.RdCard(AutoFile);
FIO.Close(AutoFile);

Concat(Spelersloc,iloc,'Speler.txt');
SpelersFile:=FIO.Open(Spelersloc);
FIO.RdStr(SpelersFile,Gamer.naam);
Gamer.Track:=FIO.RdCard(SpelersFile);
Gamer.MaxTrack:=FIO.RdCard(SpelersFile);
z:=FIO.RdCard(SpelersFile);
CASE z OF
    0: Gamer.GekozenAuto:=SportAuto;
   |1: Gamer.GekozenAuto:=SportAuto;
   |2: Gamer.GekozenAuto:=Ferari;
   |3: Gamer.GekozenAuto:= Vrachtwagen;
END;(*case*)
Gamer.MaxAuto:=FIO.RdCard(SpelersFile);
Gamer.VerzameldePunten:=FIO.RdCard(SpelersFile);
FIO.Close(SpelersFile);
END InladenGegevens;
(*---------------------------------------------------------------*)
PROCEDURE Save;
VAR
SpelersFile,AutoFile:FIO.File;
SportAutoFileLoc,FerrariFileLoc,VrachtwagenFileLoc:ARRAY[1..40] OF CHAR;


BEGIN
SetUpdateMode(FALSE);
DrawSavedBitmap(0,0,ID10);
Update();
SetUpdateMode(TRUE);

Concat(SportAutoFileLoc,sloc,'SportAuto.txt');
AutoFile:=FIO.Open(SportAutoFileLoc);
FIO.WrStr(AutoFile,gLegeLijn);
FIO.Close(AutoFile);
AutoFile:=FIO.Open(SportAutoFileLoc);
FIO.WrCard(AutoFile,VAL(CARDINAL, SportAuto.MaxSnelheid),4);
FIO.WrChar(AutoFile,' ');
FIO.WrCard(AutoFile,VAL(CARDINAL, SportAuto.OptrekSnelheid*100.0),4);
FIO.WrChar(AutoFile,' ');
FIO.WrCard(AutoFile,VAL(CARDINAL, SportAuto.RemSnelheid*10.0),4);
FIO.WrChar(AutoFile,' ');
FIO.WrCard(AutoFile,SportAuto.MaxBrandstof,4);
FIO.Close(AutoFile);


Concat(FerrariFileLoc,sloc,'Ferrari.txt');
AutoFile:=FIO.Open(FerrariFileLoc);
FIO.WrStr(AutoFile,gLegeLijn);
FIO.Close(AutoFile);
AutoFile:=FIO.Open(FerrariFileLoc);
FIO.WrCard(AutoFile,VAL(CARDINAL, Ferari.MaxSnelheid),4);
FIO.WrChar(AutoFile,' ');
FIO.WrCard(AutoFile,VAL(CARDINAL, Ferari.OptrekSnelheid*100.0),4);
FIO.WrChar(AutoFile,' ');
FIO.WrCard(AutoFile,VAL(CARDINAL, Ferari.RemSnelheid*10.0),4);
FIO.WrChar(AutoFile,' ');
FIO.WrCard(AutoFile,Ferari.MaxBrandstof,4);
FIO.Close(AutoFile);


Concat(VrachtwagenFileLoc,sloc,'Vrachtwagen.txt');
AutoFile:=FIO.Open(VrachtwagenFileLoc);
FIO.WrStr(AutoFile,gLegeLijn);
FIO.Close(AutoFile);
AutoFile:=FIO.Open(VrachtwagenFileLoc);
FIO.WrCard(AutoFile,VAL(CARDINAL, Vrachtwagen.MaxSnelheid),4);
FIO.WrChar(AutoFile,' ');
FIO.WrCard(AutoFile,VAL(CARDINAL, Vrachtwagen.OptrekSnelheid*100.0),4);
FIO.WrChar(AutoFile,' ');
FIO.WrCard(AutoFile,VAL(CARDINAL, Vrachtwagen.RemSnelheid*10.0),4);
FIO.WrChar(AutoFile,' ');
FIO.WrCard(AutoFile,Vrachtwagen.MaxBrandstof,4);
FIO.Close(AutoFile);


SpelersFile:=FIO.Open(loc);
FIO.WrStr(SpelersFile,gLegeLijn);
FIO.Close(SpelersFile);
SpelersFile:=FIO.Open(loc);
FIO.WrStr(SpelersFile,Gamer.naam);
FIO.WrCard(SpelersFile,Gamer.Track,4);
FIO.WrCard(SpelersFile,Gamer.MaxTrack,4);
FIO.WrCard(SpelersFile,Gamer.GekozenAutoNr,4);
FIO.WrCard(SpelersFile,Gamer.MaxAuto,4);
FIO.WrCard(SpelersFile,Gamer.VerzameldePunten,8);
FIO.Close(SpelersFile);

END Save;
(*---------------------------------------------------------------------*)
PROCEDURE PointOut(y,zc:CARDINAL);
VAR	z:CARDINAL;
BEGIN
	Rectangle(trans,20+trans,20+trans,180+trans,Wit,TRUE);
 	FOR z:=1 TO zc DO
 		IF (y >= (20*z+trans) )AND (y < (20 +20*z+trans) )
		THEN
		Disc(10+trans,trans+(60+40*(z-1))/2,3,Zwart); 	(*(60+40z)/2 is het midden*)
                END; (*IF*)
 	END;  (*FOR*)
END PointOut;
(*---------------------------------------------------------------------*)
PROCEDURE Showqwerty;
VAR
	x : CHAR;
BEGIN
SetUpdateMode(FALSE);
DrawSavedBitmap(0,0,ID6);
Update();
SetUpdateMode(TRUE);
x:=RdKey();
Rectangle(0,0,SCREEN_SIZE_X,SCREEN_SIZE_Y,Zwart,TRUE);
END Showqwerty;
(*---------------------------------------------------------------------*)
PROCEDURE Welkomswoord;
VAR i:CARDINAL;
	WelkomsWoordZin: ARRAY [1..100] OF CHAR;
	TxtFile:FIO.File;
	a:CHAR;
BEGIN
SetUpdateMode(FALSE);
DrawSavedBitmap(0,0,ID0);
Update();
SetUpdateMode(TRUE);
TxtFile:=FIO.OpenRead('Welkomswoord.txt');
	FOR i:=1 TO 15 DO
	FIO.RdStr(TxtFile,WelkomsWoordZin);
	RawOutText(20,100+25*i,Zwart,WelkomsWoordZin);
	END;	(*For i*)
	RawOutText(0,0,Wit,'');	(*Clear Buffer*)
FIO.Close(TxtFile);
a:=RdKey();
END Welkomswoord;
(*---------------------------------------------------------------------*)	
PROCEDURE Launch;
TYPE BitmapEn = (LauncherBackground);
     ColourSb = [0..16]; (* for colour codes, see Graph.def. Color=16 means transparant *)
     DigitSb = [0..9];

  VAR
	      i,x,y,z,l,p,b,zc,oC,n:CARDINAL;
	      myFile: FIO.File;
	      istr,inhf,naam_temp: ARRAY[1..12] OF CHAR  ;
	      sln: ARRAY[1..6] OF CHAR;
	      posKlik,posKlik2,Vol,c,Open,d,helpot: BOOLEAN;
		  MousePosition: MsData;

BEGIN
  SetUpdateMode(TRUE);
  Rectangle(0,0,SCREEN_SIZE_X,SCREEN_SIZE_Y,Zwart,TRUE);
  b:=0;
  Vol:=FALSE;
  d:=FALSE;
  Open:=FALSE;
  helpot:=FALSE;
  oC:=SetBkColor(Wit);
  SetTextWindow (0, 0, SCREEN_SIZE_X, SCREEN_SIZE_Y);
  Welkomswoord;
  SetUpdateMode(FALSE);
  DrawSavedBitmap(0,0,ID0);
  Update();
  SetUpdateMode(TRUE);
  RawOutText (trans, trans, Zwart,"StreetRacer alfa Launcher" );
  DrawSavedBitmap(0,hy,ID14);
  FOR p := 1 TO 5 DO
  CASE p OF
   1:  sln:="Slot 1";
        loc:= "SaveFiles/Slot_1/Speler.txt";
  |2:  sln:="Slot 2";
  	loc:= "SaveFiles/Slot_2/Speler.txt";
  |3:  sln:="Slot 3";
  	loc:= "SaveFiles/Slot_3/Speler.txt";
  |4:  sln:="Slot 4";
  	loc:= "SaveFiles/Slot_4/Speler.txt";
  |5:  sln:="Slot 5";
  	loc:= "SaveFiles/Slot_5/Speler.txt";
  END; (*CASE*)
  RawOutText(20+trans,20*p+trans,Zwart,sln);
  myFile:=FIO.Open(loc);
  FIO.RdStr(myFile, inhf);
  FIO.Close(myFile);
  IF NOT Match(inhf,"<empty slot>") THEN
  b:=b+1;
  	IF b=5 THEN
  	RawOutText(20+trans,120+trans,Zwart,"Clear Slot");
	Vol:=TRUE;
  	END; (*IF*)
  END;   (*IF*)
  RawOutText(80+trans,20*p+trans,Zwart,inhf);
  END; (*FOR*)
  RawOutText (0+trans, 160+trans, Wit,"" );	(*Om de laatste in buffer staande data uit te schrijven*)

	
c:=FALSE;
posKlik:=FALSE;

WHILE posKlik=FALSE DO
    Delay(75);
	GetStatus(MousePosition);
	x:=MousePosition.col;
	y:=MousePosition.row;
	
 	IF Vol THEN zc:=6;
	ELSE zc:=5;
	END;
	
	PointOut(y,zc);
	
	IF MousePosition.left_pressed  THEN
	FOR z:=1 TO zc DO
 		IF (y >= (20*z+trans) )AND (y < (20 +20*z+trans) ) THEN
			
		CASE  z OF
		1 :     sloc:= "SaveFiles/Slot_1/";
				Concat(loc,sloc,'Speler.txt');
				myFile:= FIO.Open(loc);
				
		|2:     sloc:= "SaveFiles/Slot_2/";
				Concat(loc,sloc,'Speler.txt');
				myFile:= FIO.Open(loc);

		|3: 	sloc:= "SaveFiles/Slot_3/";
				Concat(loc,sloc,'Speler.txt');
				myFile:= FIO.Open(loc);
				
		|4:     sloc:= "SaveFiles/Slot_4/";
				Concat(loc,sloc,'Speler.txt');
				myFile:= FIO.Open(loc);

		|5:     sloc:= "SaveFiles/Slot_5/";
				Concat(loc,sloc,'Speler.txt');
				myFile:= FIO.Open(loc);

		|6:     c:=TRUE; 		
		END (*Case*)  ;
		
		posKlik:=TRUE;
		
		ELSIF   (y >= hy) AND (x <= hx)
				THEN helpot:=Help(helpot,'Launcher',4,50,SCREEN_SIZE_Y/2+100,500,SCREEN_SIZE_Y-175) ;
				
		
      END; (*IF*)
 	END;  (*FOR*)
		
	END; (*IsButtonPressed*)	
END; (*WHILE*)

IF   c=TRUE
THEN
posKlik2:=FALSE;
SetUpdateMode(FALSE);
DrawSavedBitmap(0,0,ID0);
Update();
SetUpdateMode(TRUE);
RawOutText (trans, trans, Zwart,"Clear Slot?" );
  FOR p := 1 TO 5 DO

  CASE p OF
   1:  sln:="Slot 1";
        loc:= "SaveFiles/Slot_1/Speler.txt";
  |2:  sln:="Slot 2";
  	loc:= "SaveFiles/Slot_2/Speler.txt";
  |3:  sln:="Slot 3";
  	loc:= "SaveFiles/Slot_3/Speler.txt";
  |4:  sln:="Slot 4";
  	loc:= "SaveFiles/Slot_4/Speler.txt";
  |5:  sln:="Slot 5";
  	loc:= "SaveFiles/Slot_5/Speler.txt";
  END; (*CASE*)
  RawOutText(20+trans,20*p+trans,Zwart,sln);
  myFile:=FIO.Open(loc);
  FIO.RdStr(myFile, inhf);
  RawOutText(80+trans,20*p+trans,Zwart,inhf);
  FIO.Close(myFile);
  END; (*For p*)


REPEAT
	Delay(100);
	GetStatus(MousePosition);
	x:=MousePosition.col;
	y:=MousePosition.row;	
	PointOut(y,5);
  IF MousePosition.left_pressed  THEN
	FOR z:=1 TO 5 DO
 		IF (y >= (20*z+trans) )AND (y < (20 +20*z+trans) ) THEN
	
		CASE  z OF
		 1:     sloc:= "SaveFiles/Slot_1/";
				
		|2:     sloc:= "SaveFiles/Slot_2/";
				
		|3: 	sloc:= "SaveFiles/Slot_3/";
				
		|4:     sloc:= "SaveFiles/Slot_4/";
				
		|5:     sloc:= "SaveFiles/Slot_5/";
			
		END; (*Case z*)
		Concat(loc,sloc,'Speler.txt');
		END; (*IF y*)
	END; (*For z*)
	InladenGegevens('SaveFiles/Standaard/');
	Save;
	posKlik2:=TRUE;
	c:=FALSE;
	Launch;
  END;  (*IF button*)
UNTIL posKlik2=TRUE;
ELSIF d=TRUE
      THEN Delay(75); d:=FALSE;
ELSE
    FIO.Close(myFile);
 	InladenGegevens(sloc);
	
	IF Match(Gamer.naam,"<empty slot>") THEN
	(*Nieuwe speler aanmaken*)
	Showqwerty;
	SetUpdateMode(FALSE);
	DrawSavedBitmap(0,0,ID0);	(*redraw bitmap*)
	Update();
	SetUpdateMode(TRUE);
	myFile:=FIO.Open(loc);
	RawOutText(trans+10,trans+10,0,"Nickname?: ");
	RawOutText(trans+10,trans+30,0,"Characters only");
	RawOutText(trans+10,trans+50,0,"(1 min | 12 max)");
	(*procedure met hulp van G. v.d.Perre*)
	
	REPEAT
	RawOutText(trans+10,trans+70, Zwart, '|');
	Delay(500) ;
	RawOutText(trans+10,trans+70, Wit, '|');
	Delay(500);
	UNTIL KeyPressed() ;	
	n:=1;
	WHILE n < AantalNaam DO
		IF KeyPressed()  THEN
		naam_temp[n]:= RdKey();
		IF naam_temp[n]=VAL(CHAR, 13) THEN        	    (* bij enter : eind naaminvoering*)
	   	naam_temp[n]:=VAL(CHAR, 0);
	   	n:=AantalNaam;
		END;   (*if*)
		IF naam_temp[n]=VAL(CHAR, 8) THEN
	       	 naam_temp[n-1] := VAL(CHAR, 0);          (* Gebruik van de backspace*)
			CASE	n OF 2 :                                                           (*hier zit nog een foutje in => index fout*)
					n:=n-2;
					Rectangle(trans+10,trans+70,trans+170,trans+90,Wit, TRUE);   (*zodat de gewiste tekst wordt bedekt*)
					RawOutText(trans+10,trans+70, Wit,naam_temp);
					n:=n+1;				
			ELSE n:=1;
			END; (*Case*)
		END; (*IF*)
		RawOutText(trans+10,trans+70, Zwart,naam_temp);
		n:=n+1;
	END; (*If keypressed*)
	END; (*While*)	(*Einde hulp Greet v.d.Perre*)

	
	l:=Length(naam_temp);
		i:=12-l; CASE  i OF
		 0: istr:="";
		|1: istr:=" ";
		|2: istr:="  ";
		|3: istr:="   ";
		|4: istr:="    ";
		|5: istr:="     ";
		|6: istr:="      ";
		|7: istr:="       ";
		|8: istr:="        ";
		|9: istr:="         ";
		|10: istr:="          ";
		|11: istr:="           ";
		END; (*Case*)
        Concat(Gamer.naam,naam_temp,istr);
	FIO.WrStr(myFile,Gamer.naam);
	FIO.Close(myFile);					(*Spel Starten*)
	END; (*IF match*)
END; (*IF c*)
END Launch;

END Launcher.