<* WOFF + *>
<*+M2ADDTYPES   *>
IMPLEMENTATION MODULE Game;

<* NOOPTIMIZE + *>

	FROM IO IMPORT WrCard,WrLn,RdKey,KeyPressed, RdLn,  RdLnOnWr;
	FROM Gegevens IMPORT  SCREEN_SIZE_X ,SCREEN_SIZE_Y,  Afstand, Tijd, gTijdsArray, gAfstand, gAutoPositieX, gAutoPositieY, SnelheidAndereAutos, LengteBoom, BreedteBoom, LengteGeparkeerdeAuto, BreedteGeparkeerdeAuto, LengteGastank, BreedteGastank, BrandStofVerbruik, gAfstandBenzine,PuntenTeller;
	FROM Graph IMPORT Init,SetUpdateMode, Update, PutImage, ClearScreen,_clrWHITE,_clrBLACK,Rectangle, _clrGREEN, _clrRED,RawOutText, SetBkColor;
	FROM StandardBitmap IMPORT DrawNumber, DrawSavedBitmap, DrawBitmapFile, DrawMaskFile;
	FROM Lib IMPORT RANDOM, Delay;
	FROM track IMPORT gMatrixBaan, DamageMeter, ObjectRandenRijdendeAuto;
   FROM track IMPORT CleangMatrixBaan,RandomizeTrack , CheckForObjectsInTrack, OlieMeter, LengteTrack, TestCrash, Achtergrond, SnelheidsMeter, ObjectRanden, AfstandStippenlijn,ChronoMeter, LevelDisplayer;
   FROM StandardMouse IMPORT InitMouseGraphWindow;
	FROM MsMouse IMPORT MsData, InitMouse, GetStatus, GetPress, GetRelease, _MS_LEFT, _MS_RIGHT;
	FROM Gegevens IMPORT Gamer;
	FROM Afbeeldingen IMPORT width, hight,BoomAfbeelding,BoomAfbeeldingMask,GastankAfbeelding,GeparkeerdeAutoAfbeelding,RijdendeAutoAfbeelding, GameOverAfbeelding, GameOverMask,FinishAfbeelding;
   FROM HighScores IMPORT WrPointsToFiles;
VAR
    Snelheid: REAL;
    x: CHAR;


PROCEDURE Rijden();     (*Made by: Robin, Jonathan*)
	VAR RandomobjectPositieX, RandomobjectPositieY,PositieAutoX,PositieAutoY, FinishTijdCard: CARDINAL;
	VAR FinishTijd: LONGINT;

BEGIN

	
    RdLn;
    Snelheid:=0.0;
    gAutoPositieX:=SCREEN_SIZE_X/20*9;
    gAutoPositieY:=SCREEN_SIZE_Y/10*8;


    	(*Initialisatie Track*)
	 CleangMatrixBaan();
	 RandomizeTrack(gMatrixBaan,Gamer.Track);
	 CheckForObjectsInTrack; (*zorgt ervoor dat geen 2 bitmaps op dezelfde plaats komen te staan*)
	 ObjectRanden('B',LengteBoom,BreedteBoom);
	 ObjectRanden('P',LengteGeparkeerdeAuto,BreedteGeparkeerdeAuto );
	 ObjectRanden('G',LengteGastank,BreedteGastank);
	
	 gMatrixBaan[LengteTrack-3*SCREEN_SIZE_Y][SCREEN_SIZE_X/10*3]:='F';  (* Finish *)
	
	 gAfstand:=1;
	 gAfstandBenzine:=0;
	 gTijdsArray[1]:=0;
	 gTijdsArray[2]:=0;
 	 Tijd(0);
	 Tijd(2);         (*volgorde niet veranderen aub!*)
	 Tijd(1);
	
	 SetUpdateMode(FALSE);

LOOP

Tijd(1);
RdLn;
IF KeyPressed()

  THEN
    x:=RdKey();
    IF (ORD(x) = 0) THEN
    	x:=RdKey();
    END;

    IF       ORD(x)=072
      THEN
             Snelheid:=Snelheid+Gamer.GekozenAuto.OptrekSnelheid;
	
	    IF Snelheid > Gamer.GekozenAuto.MaxSnelheid
	    	 THEN Snelheid := Snelheid - Gamer.GekozenAuto.OptrekSnelheid;
		 END;		

    ELSIF   ORD(x)=075
    	THEN    x:='j';		      (*Clear buffer*)
		
	     gAutoPositieX:= gAutoPositieX-Gamer.GekozenAuto.ZijwaartseSnelheid;

	IF gAutoPositieX > (SCREEN_SIZE_X/10)
    		THEN gAutoPositieX:= gAutoPositieX;
	ELSE gAutoPositieX:= gAutoPositieX+Gamer.GekozenAuto.ZijwaartseSnelheid;

	END;	
	
    ELSIF   ORD(x)=077
        THEN     x:='j';		      (*Clear buffer*)
	     gAutoPositieX:= gAutoPositieX+Gamer.GekozenAuto.ZijwaartseSnelheid;

	IF gAutoPositieX < (SCREEN_SIZE_X/10*9-70)
  		THEN  gAutoPositieX:= gAutoPositieX;
	ELSE  gAutoPositieX:= gAutoPositieX-Gamer.GekozenAuto.ZijwaartseSnelheid;

	END;
	
    ELSIF   ORD(x)= 080
       THEN  Snelheid:=Snelheid-Gamer.GekozenAuto.RemSnelheid;

           IF Snelheid < 0.0
	
	     THEN Snelheid:=0.0;
	
	     ELSE Snelheid:=Snelheid;
	   END;
					

  ELSIF    x='f'
      THEN		
	     gAutoPositieY:= gAutoPositieY+8;

	IF gAutoPositieY < (SCREEN_SIZE_Y/10*9)
    		THEN gAutoPositieY:= gAutoPositieY;
	ELSE gAutoPositieY:= gAutoPositieY-8;

	END;
	
  ELSIF    x='r'
     THEN		
	
	IF Snelheid > 0.0 THEN
	
		gAutoPositieY:= gAutoPositieY-8;

		IF gAutoPositieY > (SCREEN_SIZE_Y/10)
    			THEN gAutoPositieY:= gAutoPositieY;
		ELSE gAutoPositieY:= gAutoPositieY+8;

		END;
	
	END;
	
  END;

  ELSIF x =' '        (* Handrem*)
       THEN
            IF Gamer.GekozenAuto.Handrem > 0
            THEN Gamer.GekozenAuto.Handrem:= Gamer.GekozenAuto.Handrem - 1;
	         Snelheid :=0.0;
	    END;	
						
  ELSIF x='p'
       THEN
       	  REPEAT
			 PutImage(gAutoPositieX, gAutoPositieY,Gamer.GekozenAuto.AfbeeldingAutoMask, 1);
		    	PutImage(gAutoPositieX, gAutoPositieY,Gamer.GekozenAuto.AfbeeldingAuto, 0);
		    	SnelheidsMeter(Snelheid);

			OlieMeter();

			DamageMeter();

			ChronoMeter();
		
		    Update();
          UNTIL KeyPressed();
      END;


		
Achtergrond;

(* Berekenen van de reeds afgelegde weg *)
Afstand(Snelheid);


(* Tekenen van randomobjecten *)

ObjectRandenRijdendeAuto;    (* Aanpassen van de randen van andere auto's *)


FOR RandomobjectPositieY:=gAfstand+(SCREEN_SIZE_Y-1) TO gAfstand BY -1 DO  (*Made By: Jonathan *)
		FOR RandomobjectPositieX:=0 TO SCREEN_SIZE_X DO
		(* Tekenen van Bomen *)	
			IF gMatrixBaan[RandomobjectPositieY][RandomobjectPositieX]='B' THEN
	
				PutImage(RandomobjectPositieX,(SCREEN_SIZE_Y+gAfstand-RandomobjectPositieY), BoomAfbeelding,0);
			END;
		(* Tekenen van Gaskannetjes *)	
			IF gMatrixBaan[RandomobjectPositieY][RandomobjectPositieX]='G' THEN
				PutImage(RandomobjectPositieX,(SCREEN_SIZE_Y+gAfstand-RandomobjectPositieY), GastankAfbeelding,0);
			END;
		(* Tekenen van Geparkeerde auto's *)	
			IF gMatrixBaan[RandomobjectPositieY][RandomobjectPositieX]='P' THEN
				PutImage(RandomobjectPositieX,(SCREEN_SIZE_Y+gAfstand-RandomobjectPositieY), GeparkeerdeAutoAfbeelding,0);
			END;
			
		(*	IF gMatrixStippenlijn[RandomobjectPositieY]='S' THEN
				PutImage( SCREEN_SIZE_X/2-2,(SCREEN_SIZE_Y+gAfstand-RandomobjectPositieY) , StippelijnAfbeelding, 0);
			END;     *)
			
						
			IF gMatrixBaan[RandomobjectPositieY][RandomobjectPositieX]='A' THEN
				PutImage(RandomobjectPositieX,(SCREEN_SIZE_Y+gAfstand-RandomobjectPositieY), RijdendeAutoAfbeelding,0);
			END;
			
			IF gMatrixBaan[RandomobjectPositieY][RandomobjectPositieX]='F' THEN
				PutImage(RandomobjectPositieX,(SCREEN_SIZE_Y+gAfstand-RandomobjectPositieY), FinishAfbeelding,0);
			END;	
			
		END;   (*for*)
	END;   (*for*)


PutImage(gAutoPositieX, gAutoPositieY, Gamer.GekozenAuto.AfbeeldingAutoMask, 1);
PutImage(gAutoPositieX, gAutoPositieY, Gamer.GekozenAuto.AfbeeldingAuto, 0);


	
TestCrash(Snelheid);

BrandStofVerbruik();

IF (Gamer.GekozenAuto.DamageMeter = 0.0) OR (Gamer.GekozenAuto.Brandstof = 0)   (*Made By Robin, Jonathan*)
 	THEN Rectangle(0,0,SCREEN_SIZE_X,SCREEN_SIZE_Y,_clrBLACK, TRUE) ;
	     PutImage(SCREEN_SIZE_X/2-136, SCREEN_SIZE_Y/2-75, GameOverMask, 1);
	     PutImage(SCREEN_SIZE_X/2-136, SCREEN_SIZE_Y/2-75, GameOverAfbeelding, 0);
		  		IF  Gamer.GekozenAuto.DamageMeter = 0.0 THEN
		  		RawOutText(SCREEN_SIZE_X/2-75, SCREEN_SIZE_Y/2+50, 10 , "Your car has exploded! ");
				ELSIF  Gamer.GekozenAuto.Brandstof = 0 THEN
				RawOutText(SCREEN_SIZE_X/2-50, SCREEN_SIZE_Y/2+50, 10 , "Out of gas! ");
				END;
		  Gamer.GekozenAuto.DamageMeter:=Gamer.GekozenAuto.MaxDamageMeter;
		  Gamer.GekozenAuto.Brandstof:=Gamer.GekozenAuto.MaxBrandstof;
		  Snelheid:=0.0;
	     Update();
	     Delay(3000);
		  Rectangle(0,0,SCREEN_SIZE_X,SCREEN_SIZE_Y,10, TRUE) ;
	     EXIT;
	
END;
(*FINISH*)    (*Made by:Jonathan*)
IF (gAfstand+SCREEN_SIZE_Y-gAutoPositieY) > (LengteTrack-3*SCREEN_SIZE_Y+20)

THEN  Tijd(2);
      FinishTijd := gTijdsArray[2]/100-gTijdsArray[0]/100;
		FinishTijdCard:=VAL(CARDINAL, FinishTijd);
		
		Rectangle(0,0,SCREEN_SIZE_X,SCREEN_SIZE_Y, _clrBLACK, TRUE);
		
      RawOutText(SCREEN_SIZE_X/2-100, SCREEN_SIZE_Y/2-200, 10 , "Congratulations! You finished! ");

            RawOutText(SCREEN_SIZE_X/2-100, SCREEN_SIZE_Y/2-125, 10 , "Your Time: ");
      		DrawNumber(SCREEN_SIZE_X/2+100, SCREEN_SIZE_Y/2-118,FinishTijdCard,10,_clrBLACK);
		
		Gamer.VerzameldePunten:=Gamer.VerzameldePunten+PuntenTeller(FinishTijdCard);
      		
				RawOutText(SCREEN_SIZE_X/2-100, SCREEN_SIZE_Y/2-100, 10 , "Credits gained: ");
				DrawNumber(SCREEN_SIZE_X/2+100, SCREEN_SIZE_Y/2-93, PuntenTeller(FinishTijdCard),10,_clrBLACK );
				
				RawOutText(SCREEN_SIZE_X/2-100, SCREEN_SIZE_Y/2-75, 10 , "Total credits: ");
				DrawNumber(SCREEN_SIZE_X/2+100, SCREEN_SIZE_Y/2-68, Gamer.VerzameldePunten,10,_clrBLACK );
				                    (*10= kleur wit*)
		IF Gamer.Track=Gamer.MaxTrack	THEN	
			Gamer.MaxTrack:=Gamer.Track+1;
			
			RawOutText(SCREEN_SIZE_X/2-100, SCREEN_SIZE_Y/2-50, 10 , "Track Unlocked: ");
			DrawNumber(SCREEN_SIZE_X/2+100, SCREEN_SIZE_Y/2-43, Gamer.MaxTrack,10,_clrBLACK );
		END;
		
				
		
		IF Gamer.MaxTrack =4
		THEN 	Gamer.MaxAuto :=2;
				RawOutText(SCREEN_SIZE_X/2-100, SCREEN_SIZE_Y/2-25, 10 , "Car Unlocked: Ferari ");
		ELSIF Gamer.MaxTrack =8
		THEN 	Gamer.MaxAuto :=3;
				RawOutText(SCREEN_SIZE_X/2-100, SCREEN_SIZE_Y/2-25, 10 , "Car Unlocked: Vrachtwagen ");
				
		END;
			  RawOutText(200, SCREEN_SIZE_Y-25, 10 , "You will automatically go back to the menu ");
			  WrPointsToFiles(FinishTijdCard, Gamer.naam);
		Update();
		Delay(6000);			
		EXIT;
		
END;


(*Rechthoekje tekenen voor de metertjes*)
Rectangle(SCREEN_SIZE_X/20*14+20, 0 ,  SCREEN_SIZE_X, SCREEN_SIZE_Y/30+35*4, _clrBLACK, TRUE);         (*35= Plaats van 1 meter*)


SnelheidsMeter(Snelheid);

OlieMeter();

DamageMeter();

ChronoMeter();

LevelDisplayer();
	



Tijd(2);

Update();  (*Teken alle images*)


RdLn;
				
END;
	
		
END Rijden;


BEGIN

END Game.