IMPLEMENTATION MODULE KiesTrack;
<* +M2ADDTYPES *>
  <* NOOPTIMIZE + *>  (* For the Debugger *)
   FROM Graph IMPORT Rectangle, PutImage, _clrBLACK, _clrLIGHTGREEN, Update, SetUpdateMode;
   FROM Graph IMPORT RawOutText;
   FROM Gegevens IMPORT SCREEN_SIZE_X, SCREEN_SIZE_Y,Gamer,hy,hx;
   FROM StandardBitmap IMPORT DrawNumber;
   FROM MsMouse IMPORT MsData,GetStatus;
   FROM Lib IMPORT Delay;
   FROM Afbeeldingen IMPORT PijlBoven, PijlBeneden, ID4, DoneAfbeelding,ID14;
   FROM Launcher IMPORT Help;




PROCEDURE KeuzeTrack;                (*Made by: Jonathan*)
	VAR	    x,y: CARDINAL;
    		MousePosition: MsData;
			Bool:BOOLEAN;

BEGIN

	LOOP
		SetUpdateMode(TRUE);

		Delay(100);
		GetStatus(MousePosition);
		x:=MousePosition.col;
		y:=MousePosition.row;

		IF MousePosition.left_pressed  THEN
		
			
			(*Pijltje naar boven*)
			
			IF (y>=SCREEN_SIZE_Y/2-40) AND (y<=SCREEN_SIZE_Y/2-40+32)  AND (x>=SCREEN_SIZE_X/2+25) AND (x<=SCREEN_SIZE_X/2+25+60) THEN
				IF Gamer.Track<9 THEN	  (*waarde van Gamer.Track is maximaal 9*)
					IF Gamer.Track<=Gamer.MaxTrack THEN Gamer.Track:=Gamer.Track+1;
					END;
				END;
			
	      (*Pijltje naar beneden*)
			
			ELSIF (y>=SCREEN_SIZE_Y/2+40) AND (y<=SCREEN_SIZE_Y/2+40+32)  AND (x>=SCREEN_SIZE_X/2+25) AND (x<=SCREEN_SIZE_X/2+25+60) THEN
		
			
				IF Gamer.Track#1 THEN Gamer.Track:=Gamer.Track-1;
			
				END;
				
			ELSIF (y>=SCREEN_SIZE_Y-76) AND (y<=SCREEN_SIZE_Y)  AND (x>=SCREEN_SIZE_X-129) AND (x<=SCREEN_SIZE_X) THEN   (*Done*)
			
				RETURN;
				
			END;  (*IF-functies over de muisposities*)
					IF   (y >= hy) AND (x <= hx) THEN
					Bool:=Help(Bool,'Tr',2,hx+10,hy,SCREEN_SIZE_X-hx,SCREEN_SIZE_Y);
					END;
	
      END; (*IF  MousePosition.left_pressed*)

	SetUpdateMode(FALSE);

	Rectangle(0, 0, SCREEN_SIZE_X,SCREEN_SIZE_Y , _clrLIGHTGREEN, TRUE);
	PutImage(0,0,ID4,1);  (*Achtergrondafbeelding Track*)

	PutImage(SCREEN_SIZE_X/2+25, SCREEN_SIZE_Y/2-40, PijlBoven, 1);
	PutImage(SCREEN_SIZE_X/2+25, SCREEN_SIZE_Y/2+40, PijlBeneden, 1);
	PutImage(SCREEN_SIZE_X-129, SCREEN_SIZE_Y-76, DoneAfbeelding, 1);

	RawOutText(SCREEN_SIZE_X/2-25, SCREEN_SIZE_Y/2+5, 0, "Track");
	DrawNumber(SCREEN_SIZE_X/2+53, SCREEN_SIZE_Y/2+12, Gamer.Track,  _clrBLACK, _clrLIGHTGREEN);
	
	IF Gamer.Track>Gamer.MaxTrack THEN
		RawOutText(SCREEN_SIZE_X/2+100, SCREEN_SIZE_Y/2+5, 0, "Locked");
	END;
	
	IF Gamer.Track=9 THEN
	   RawOutText(SCREEN_SIZE_X/2+100, SCREEN_SIZE_Y/2+5, 0, "All Levels unlocked");
	END;

	Update();
	
END;   (*loop*)

END KeuzeTrack;


BEGIN

END KiesTrack.

