IMPLEMENTATION MODULE Launcher;

  <* +M2ADDTYPES *>
  <* NOOPTIMIZE + *>  (* For the Debugger *)
  FROM IO IMPORT WrStr, WrLn, RdKey, WrCard,KeyPressed;
  FROM Lib IMPORT Delay; (* Delay: let the program wait a little time *)
    IMPORT FIO; (*File import*)
  (* de graphics library vind je onder C:/Bin/Xds/Def/Ts/Graph.def *)
  FROM Graph IMPORT Rectangle,RawOutText,SetTextWindow, Disc;
  FROM Graph IMPORT SetUpdateMode,Update,SetBkColor,_clrBLACK,_clrLIGHTGREEN; (* for bitmap saving *)
  (* deze 16 kleuren zijn constantes gaande van 0 tot 15 *)
  FROM Str IMPORT Match,Length,Concat;
  FROM StandardBitmap IMPORT DrawSavedBitmap;
  FROM MsMouse IMPORT MsData,GetStatus;
  FROM Gegevens IMPORT SCREEN_SIZE_X,SCREEN_SIZE_Y, Gamer;
  FROM Afbeeldingen IMPORT ID0, ID6;
  FROM Cars IMPORT SportAuto,Ferari, Vrachtwagen;

(*----------------------------------------------------------------*)	
PROCEDURE Help (Open:BOOLEAN;name:ARRAY OF CHAR):BOOLEAN;
CONST   map='_Help/' ;
	hx=50;
	hy=630;
VAR Inh : ARRAY [1..400] OF CHAR;    (*Inhoud*)
    Floc : ARRAY [1..20] OF CHAR;    (*Floc: File Location*)
    F : FIO.File;                    (*F:File*)
	i:CARDINAL;	
BEGIN
IF Open = FALSE THEN
Concat(Floc,map,name);Concat(Floc,Floc,'.txt');
F:=FIO.Open(Floc);
FOR i:=1 TO 2 DO
	FIO.RdStr(F, Inh);
	RawOutText(hx+10,hy+20*(i-1),Zwart,Inh);
END; (*FOR*)
FIO.Close(F);
RawOutText(690,690,Wit,''); (*Clear Buffer*)
RETURN TRUE;
ELSE Rectangle(hx+10,hy,SCREEN_SIZE_X-hx,SCREEN_SIZE_Y,Wit,TRUE);
RETURN FALSE;
END; (*IF*)
END Help;
(*_--------------------------------------------------------------*)
PROCEDURE InladenGegevens;
VAR
SpelersFile,AutoFile:FIO.File;
SportAutoFileLoc,FerrariFileLoc,VrachtwagenFileLoc:ARRAY[1..40] OF CHAR;
z: CARDINAL;

BEGIN
Concat(SportAutoFileLoc,sloc,'SportAuto.txt');
AutoFile:=FIO.Open(SportAutoFileLoc);
SportAuto.MaxSnelheid:=VAL(REAL,FIO.RdCard(AutoFile));
SportAuto.OptrekSnelheid:=VAL(REAL,FIO.RdCard(AutoFile))/100.0;;
SportAuto.RemSnelheid:= VAL(REAL,FIO.RdCard(AutoFile))/10.0;
SportAuto.MaxBrandstof:=FIO.RdCard(AutoFile);
FIO.Close(AutoFile);

Concat(FerrariFileLoc,sloc,'Ferrari.txt');
AutoFile:=FIO.Open(FerrariFileLoc);
Ferari.MaxSnelheid:= VAL(REAL,FIO.RdCard(AutoFile));
Ferari.OptrekSnelheid:=VAL(REAL,FIO.RdCard(AutoFile))/100.0;
Ferari.RemSnelheid:= VAL(REAL,FIO.RdCard(AutoFile))/10.0;
Ferari.MaxBrandstof:= FIO.RdCard(AutoFile);
FIO.Close(AutoFile);

Concat(VrachtwagenFileLoc,sloc,'Vrachtwagen.txt');
AutoFile:=FIO.Open(VrachtwagenFileLoc);
Vrachtwagen.MaxSnelheid:=VAL(REAL,FIO.RdCard(AutoFile));
Vrachtwagen.OptrekSnelheid:= VAL(REAL,FIO.RdCard(AutoFile))/100.0;
Vrachtwagen.RemSnelheid:= VAL(REAL,FIO.RdCard(AutoFile))/10.0;
Vrachtwagen.MaxBrandstof:=FIO.RdCard(AutoFile);
FIO.Close(AutoFile);

SpelersFile:=FIO.Open(loc);
FIO.RdStr(SpelersFile,Gamer.naam);
Gamer.Track:=FIO.RdCard(SpelersFile);
Gamer.MaxTrack:=FIO.RdCard(SpelersFile);
z:=FIO.RdCard(SpelersFile);
CASE z OF
    0: Gamer.GekozenAuto:=SportAuto;
   |1: Gamer.GekozenAuto:=SportAuto;
   |2: Gamer.GekozenAuto:=Ferari;
   |3: Gamer.GekozenAuto:= Vrachtwagen;
END;(*case*)
Gamer.MaxAuto:=FIO.RdCard(SpelersFile);
Gamer.VerzameldePunten:=FIO.RdCard(SpelersFile);
FIO.Close(SpelersFile);

END InladenGegevens;
(*---------------------------------------------------------------*)
PROCEDURE PointOut(y,zc:CARDINAL);
VAR	z:CARDINAL;
BEGIN
	Rectangle(trans,20+trans,20+trans,180+trans,Wit,TRUE);
 	FOR z:=0 TO zc DO
 		IF (y >= (20 +20*z+trans) )AND (y < (40 +20*z+trans) )
		THEN
		Disc(10+trans,trans+(60+40*z)/2,3,_clrBLACK); 	(*(60+40z)/2 is het midden*)
                END; (*IF*)
 	END;  (*FOR*)
END PointOut;

PROCEDURE Showqwerty;
VAR
	x : CHAR;
BEGIN
SetUpdateMode(FALSE);
DrawSavedBitmap(0,0,ID6);
Update();
SetUpdateMode(TRUE);
x:=RdKey();
Rectangle(0,0,SCREEN_SIZE_X,SCREEN_SIZE_Y,0,TRUE);
END Showqwerty;


	
PROCEDURE Launch;
TYPE BitmapEn = (LauncherBackground);
     ColourSb = [0..16]; (* for colour codes, see Graph.def. Color=16 means transparant *)
     DigitSb = [0..9];

  VAR
	      i,x,y,z,l,p,b,zc,oC,n:CARDINAL;
	      myFile,myFileb: FIO.File;
	      istr,inhf,naam_temp: ARRAY[1..12] OF CHAR  ;
	      sln: ARRAY[1..6] OF CHAR;
	      posKlik,posKlik2,Vol,c,Open,d: BOOLEAN;
		  MousePosition: MsData;

BEGIN
  SetUpdateMode(TRUE);
  Rectangle(0,0,700,700,Zwart,TRUE);
  b:=0;
  Vol:=FALSE;
  d:=FALSE;
  Open:=FALSE;
  oC:=SetBkColor(_clrLIGHTGREEN);
  SetUpdateMode(FALSE);
  DrawSavedBitmap(trans,trans,ID0);
  Update();
  SetUpdateMode(TRUE);
  SetTextWindow (0, 0, SCREEN_SIZE_X, SCREEN_SIZE_Y);
  RawOutText (trans, trans, _clrBLACK,"Racegame V1.0 Launcher" );
  FOR p := 1 TO 5 DO
  CASE p OF
   1:  sln:="Slot 1";
        loc:= "SaveFiles/Slot_1/Speler.txt";
  |2:  sln:="Slot 2";
  	loc:= "SaveFiles/Slot_2/Speler.txt";
  |3:  sln:="Slot 3";
  	loc:= "SaveFiles/Slot_3/Speler.txt";
  |4:  sln:="Slot 4";
  	loc:= "SaveFiles/Slot_4/Speler.txt";
  |5:  sln:="Slot 5";
  	loc:= "SaveFiles/Slot_5/Speler.txt";
  END; (*CASE*)
  RawOutText(20+trans,20*p+trans,_clrBLACK,sln);
  myFile:=FIO.Open(loc);
  FIO.RdStr(myFile, inhf);
  IF NOT Match(inhf,"<empty slot>") THEN
  b:=b+1;
  	IF b=5 THEN
  	RawOutText(20+trans,140+trans,_clrBLACK,"Clear Slot");
	Vol:=TRUE;
  	END; (*IF*)
  END;   (*IF*)
  RawOutText(80+trans,20*p+trans,_clrBLACK,inhf);
  FIO.Close(myFile);
  END; (*FOR*)
  RawOutText (20+trans, 120+trans, _clrBLACK,"Help" );
  RawOutText (0+trans, 160+trans, _clrLIGHTGREEN,"" );	(*Om de laatste in buffer staande data uit te schrijven*)

c:=FALSE;
posKlik:=FALSE;

WHILE posKlik=FALSE DO

    Delay(50);
	GetStatus(MousePosition);
	x:=MousePosition.col;
	y:=MousePosition.row;
	
 	IF Vol THEN zc:=6;
	ELSE zc:=5;
	END;
	
	PointOut(y,zc);
	IF MousePosition.left_pressed  THEN
	FOR z:=0 TO zc DO
 		IF (y >= (20 +20*z+trans) )AND (y < (40 +20*z+trans) ) THEN
		WrStr("OpenFile");WrCard(z+1,2);
		CASE  z OF
		0 :     sloc:= "SaveFiles/Slot_1/";
				Concat(loc,sloc,'Speler.txt');
				myFile:= FIO.Open(loc);

		|1:     sloc:= "SaveFiles/Slot_2/";
				Concat(loc,sloc,'Speler.txt');
				myFile:= FIO.Open(loc);

		|2: 	sloc:= "SaveFiles/Slot_3/";
				Concat(loc,sloc,'Speler.txt');
				myFile:= FIO.Open(loc);
				
		|3:     sloc:= "SaveFiles/Slot_4/";
				Concat(loc,sloc,'Speler.txt');
				myFile:= FIO.Open(loc);

		|4:     sloc:= "SaveFiles/Slot_5/";
				Concat(loc,sloc,'Speler.txt');
				myFile:= FIO.Open(loc);

		|5:     d:=TRUE;
			Open:=Help(Open,'Launcher');
		
		|6:     c:=TRUE;

			
		END (*Case*)  ;
		
(*Hier komt tekst dat file error moet tegen gaan wanneer buiten een zone geklikt werd*)
		ELSE posKlik:=FALSE ;
                END; (*IF*)
 	END;  (*FOR*)
	posKlik:=TRUE ;
		
	END; (*IsButtonPressed*)
 (* END;  (*IF UpdateMouse*)    *)
END; (*WHILE*)
IF   c=TRUE
THEN
posKlik2:=FALSE;
SetUpdateMode(FALSE);
DrawSavedBitmap(trans,trans,ID0);
Update();
SetUpdateMode(TRUE);
RawOutText (trans, trans, _clrBLACK,"Clear Slot?" );
  FOR p := 1 TO 5 DO

  CASE p OF
   1:  sln:="Slot 1";
        loc:= "SaveFiles/Slot_1/Speler.txt";
  |2:  sln:="Slot 2";
  	loc:= "SaveFiles/Slot_2/Speler.txt";
  |3:  sln:="Slot 3";
  	loc:= "SaveFiles/Slot_3/Speler.txt";
  |4:  sln:="Slot 4";
  	loc:= "SaveFiles/Slot_4/Speler.txt";
  |5:  sln:="Slot 5";
  	loc:= "SaveFiles/Slot_5/Speler.txt";
  END; (*CASE*)
  RawOutText(20+trans,20*p+trans,_clrBLACK,sln);
  myFile:=FIO.Open(loc);
  FIO.RdStr(myFile, inhf);
  RawOutText(80+trans,20*p+trans,_clrBLACK,inhf);
  FIO.Close(myFile);
  END; (*For p*)


REPEAT
	Delay(50);
	GetStatus(MousePosition);
	x:=MousePosition.col;
	y:=MousePosition.row;	
	PointOut(y,4);
  IF MousePosition.left_pressed  THEN
	FOR z:=0 TO 4 DO
 		IF (y >= (20 +20*z+trans) )AND (y < (40 +20*z+trans) ) THEN
		WrStr("OpenFile");WrCard(z+1,2);
		CASE  z OF
		0 :     loc:= "SaveFiles/Slot_1/Speler.txt";
			myFileb:= FIO.Open(loc);
				
		|1:     loc:= "SaveFiles/Slot_2/Speler.txt";
			myFileb:= FIO.Open(loc);
				
		|2: 	loc:= "SaveFiles/Slot_3/Speler.txt";
			myFileb:= FIO.Open(loc);
				
		|3:     loc:= "SaveFiles/Slot_4/Speler.txt";
			myFileb:= FIO.Open(loc);
				
		|4:     loc:= "SaveFiles/Slot_5/Speler.txt";
			myFileb:= FIO.Open(loc);
		END; (*Case z*)
		END; (*IF y*)
	END; (*For z*)
	FIO.WrStr(myFileb,"<empty slot>");
	FIO.Close(myFileb);
	posKlik2:=TRUE;
	c:=FALSE;
	Launch;
  END;  (*IF button*)
 (* END;(*updatemouse*) *)
UNTIL posKlik2=TRUE;
ELSIF d=TRUE
      THEN Delay(100); d:=FALSE;
ELSE
        FIO.Close(myFile);
 	InladenGegevens;
	(*FIO.RdStr(myFile, Gamer.naam);
	WrLn; WrStr(Gamer.naam); WrLn;          			(*controle lijn*) *)
	
	
	IF Match(Gamer.naam,"<empty slot>") THEN
	(*Nieuwe speler aanmaken*)
	WrStr("Slot still free");
	WrLn;
	Showqwerty;
	SetUpdateMode(FALSE);
	DrawSavedBitmap(trans,trans,ID0);	(*redraw bitmap*)
	Update();
	SetUpdateMode(TRUE);
	myFile:=FIO.Open(loc);
	RawOutText(trans+10,trans+10,0,"Nickname?: ");
	RawOutText(trans+10,trans+30,0,"Characters only");
	RawOutText(trans+10,trans+50,0,"(1 min | 12 max)");
	(*procedure met hulp van G. v.d.Perre*)
	
	REPEAT
	RawOutText(trans+10,trans+70, _clrBLACK, '|');
	Delay(500) ;
	RawOutText(trans+10,trans+70, _clrLIGHTGREEN, '|');
	Delay(500);
	UNTIL KeyPressed() ;	
	n:=1;
	WHILE n < AantalNaam DO
		IF KeyPressed()  THEN
		naam_temp[n]:= RdKey();
		IF naam_temp[n]=VAL(CHAR, 13) THEN        	    (* bij enter : eind naaminvoering*)
	   	naam_temp[n]:=VAL(CHAR, 0);
	   	n:=AantalNaam;
		END;   (*if*)
		IF naam_temp[n]=VAL(CHAR, 8) THEN
	       	 naam_temp[n-1] := VAL(CHAR, 0);          (* Gebruik van de backspace*)
			CASE	n OF 2 :                                                           (*hier zit nog een foutje in => index fout*)
					n:=n-2;
					Rectangle(trans+10,trans+70,trans+170,trans+90,_clrLIGHTGREEN, TRUE);   (*zodat de gewiste tekst wordt bedekt*)
					RawOutText(trans+10,trans+70, _clrBLACK,naam_temp);
					n:=n+1;				
			ELSE n:=1;
			END; (*Case*)
		END; (*IF*)
		RawOutText(trans+10,trans+70, _clrBLACK,naam_temp);
		n:=n+1;
	END; (*If keypressed*)
	END; (*While*)	(*Einde hulp Greet v.d.Perre*)

	
	l:=Length(naam_temp);                                     (*kan ook met for lus*)
		i:=12-l; CASE  i OF
		 0: istr:="";
		|1: istr:=" ";
		|2: istr:="  ";
		|3: istr:="   ";
		|4: istr:="    ";
		|5: istr:="     ";
		|6: istr:="      ";
		|7: istr:="       ";
		|8: istr:="        ";
		|9: istr:="         ";
		|10: istr:="          ";
		|11: istr:="           ";
		END; (*Case*)
        Concat(Gamer.naam,naam_temp,istr);
	WrLn;
	FIO.WrStr(myFile,Gamer.naam);
	WrStr("New Player: "); WrStr(Gamer.naam);
	FIO.Close(myFile);					(*Spel Starten*)
	END; (*IF match*)
END; (*IF c*)
END Launch;

END Launcher.