MODULE Home;
  <* +M2ADDTYPES *>
  <* NOOPTIMIZE + *>  (* For the Debugger *)
  FROM IO IMPORT WrStr, WrLn, WrCard, WrReal, RdKey;
  FROM Lib IMPORT Delay; (* Delay: let the program wait a little time *)
    IMPORT FIO; (*File import*)
  (* de graphics library vind je onder C:/Bin/Xds/Def/Ts/Graph.def *)
  FROM Graph IMPORT Init, Rectangle,RawOutText, Update, SetUpdateMode,PutImage;
  FROM Graph IMPORT SetBkColor, _clrBLACK; (* for bitmap saving *)
  (* deze 16 kleuren zijn constantes gaande van 0 tot 15 *)
  (* FROM StandardMouse IMPORT InitMouseGraphWindow,UpdateMouse,GetMouseX,GetMouseY,MouseButton, IsButtonPressed; *)
  FROM MsMouse IMPORT InitMouse,MsData,GetStatus;
  FROM Str IMPORT Concat;
  FROM StandardBitmap IMPORT DrawSavedBitmap, DrawNumber;
  (* FROM StandardSound IMPORT InitSound,PlaySoundEvent,SoundEventEn; *)
  FROM Launcher IMPORT Help,Launch,sloc,InladenGegevens,loc,Zwart,Wit,hx,hy;
  FROM Gegevens IMPORT SCREEN_SIZE_X,SCREEN_SIZE_Y,Gamer;
  FROM Game IMPORT Rijden;
  FROM KiesAuto IMPORT KeuzeAuto;
  FROM KiesTrack IMPORT KeuzeTrack;
  FROM Afbeeldingen IMPORT LaadAfbeeldingenIn, ID1,ID2,ID5,ID7,ID9,ID10,ID11,ID12,ID13,DoneAfbeelding;
  FROM Cars IMPORT Auto,Ferari,SportAuto,Vrachtwagen;

CONST
	f1=240;  (*begin hoogte op y-as*)
	f2=400;  (*eind hoogte op y-as*)
	f3=450;  (*begin hoogte tweede lijn op y-as*)
	f4=570;  (*eind hoogte tweede lijn op y-as*)
	g1=175;  (* x-breedte *)
	g2=85;   (*verschuiving x voor lijn twee*)
	hy2=690; (*Plaats eind y-as*)
	Cy=600; (*y waarde van de Credits bij Tune*)
	Cx=150; (*x waarde van de Credits bij Tune*) (*Cx en Cy worden in # procedures opgeroepen*)
	
	
VAR
	x,y:CARDINAL;
	b: BOOLEAN;
	temp: Auto;
(*---------------------------------------------------------------*)
PROCEDURE Omlijn(x1,y1,x2,y2,dikte,color:CARDINAL);
BEGIN
Rectangle(x1-dikte,y1-dikte,x2+dikte,y1,color,TRUE);     (*Boven*)
Rectangle(x1-dikte,y1-dikte,x1,y2+dikte,color,TRUE);     (*Links*)
Rectangle(x2,y1-dikte,x2+dikte,y2+dikte,color,TRUE);	 (*Rechts*)
Rectangle(x1-dikte,y2,x2+dikte,y2+dikte,color,TRUE);	 (*Onder*)
END Omlijn;

(*----------------------------------------------------------------*)
PROCEDURE ToerijkendBudget(Prijs:CARDINAL):BOOLEAN;
BEGIN
IF Gamer.VerzameldePunten >= Prijs
THEN RETURN TRUE;
ELSE RETURN FALSE;
END; (*IF*)
END ToerijkendBudget;
(*----------------------------------------------------------------*)
PROCEDURE Aankoop(VAR MogelijkeAankoop:REAL; xPosKnop,yPosKnop,Niveau:CARDINAL);
BEGIN
IF ToerijkendBudget(Niveau) THEN
Gamer.VerzameldePunten:=Gamer.VerzameldePunten-Niveau;
MogelijkeAankoop:=(MogelijkeAankoop + 1.0);
WrReal(MogelijkeAankoop,0,0); WrStr('Dos');
Rectangle(Cx+65,Cy,Cx+120,Cy+20,Wit,TRUE);
DrawNumber(Cx+80,Cy+10,Gamer.VerzameldePunten,Zwart,Wit);
ELSE RawOutText(xPosKnop+50,yPosKnop,Zwart,'Low Budget');
END ;(*IF Toerijkend*)
END Aankoop;
(*----------------------------------------------------------------*)
PROCEDURE ControleAankoop(VAR MogelijkeAankoop2:REAL;xPosKnop,yPosKnop:CARDINAL);
CONST	Niveau1 = 750;
		Niveau2 = 1500;
		Niveau3 = 3000;
VAR		TussenVar: CARDINAL;
BEGIN
TussenVar:=VAL(CARDINAL,MogelijkeAankoop2);
CASE TussenVar OF
	 0: WrReal(MogelijkeAankoop2,0,0); WrStr('Un');Aankoop(MogelijkeAankoop2,xPosKnop,yPosKnop,Niveau1);
	 	WrReal(MogelijkeAankoop2,0,0);WrStr('Tres');
	|1: WrReal(MogelijkeAankoop2,0,0); WrStr('Un');Aankoop(MogelijkeAankoop2,xPosKnop,yPosKnop,Niveau2);WrReal(MogelijkeAankoop2,0,0);WrStr('Tres');
	|2: WrReal(MogelijkeAankoop2,0,0); WrStr('Un');Aankoop(MogelijkeAankoop2,xPosKnop,yPosKnop,Niveau3);WrReal(MogelijkeAankoop2,0,0);WrStr('Tres');
	|3: RawOutText(xPosKnop,yPosKnop,Zwart,'Max level reached');
END;(*Case mogelijkeAankoop*)
END ControleAankoop;
(*----------------------------------------------------------------*)
PROCEDURE Rc;
VAR a:CHAR;
BEGIN

SetUpdateMode(FALSE);
DrawSavedBitmap(0,0,ID2);
DrawSavedBitmap(100,250,ID12);
Update();

SetUpdateMode(TRUE);
a:=RdKey();

SetUpdateMode(FALSE);
Rijden(Gamer.Track+3);

END Rc;
(*----------------------------------------------------------------*)
PROCEDURE CarSlct;
BEGIN

ID9:=SetBkColor(Wit);
KeuzeAuto;

END CarSlct;
(*----------------------------------------------------------------*)
PROCEDURE Track;
BEGIN

ID9:=SetBkColor(Wit);
KeuzeTrack;

END Track;
(*----------------------------------------------------------------*)
PROCEDURE Tune;      (*Made by Bart, Jonathan*)
(*CONST     xWaarde =150;
		  yWaardeBoven=250;
		  yWaardeOnder=450;
		  x1WaardeDone=650;
		  x2WaardeDone=700;
		  y1WaardeDone=550;
		  y2WaardeDone=600;		
VAR Bln,Open:BOOLEAN;
	j:CARDINAL;
	MousePosition:MsData;
BEGIN
SetUpdateMode(FALSE);
DrawSavedBitmap(0,0,ID5);
Update();
SetUpdateMode(TRUE);
PutImage(SCREEN_SIZE_X-129, SCREEN_SIZE_Y-76, DoneAfbeelding, 1);
RawOutText(Cx,Cy,Zwart,'Credits: ');
DrawNumber(Cx+80,Cy+10,Gamer.VerzameldePunten,Zwart,Wit);
Bln:=FALSE;
	WHILE Bln=FALSE DO
	Delay(120);
	GetStatus(MousePosition);
		x:=MousePosition.col;
		y:=MousePosition.row;
	IF (y > yWaardeBoven) AND (y < yWaardeOnder)
	THEN Rectangle(0,yWaardeOnder,SCREEN_SIZE_X,yWaardeOnder+10,Wit,TRUE);
		FOR j:=0 TO 3 DO
			IF (x>50+j*xWaarde) AND (x<(50+(j+1)*xWaarde))
			THEN
			Rectangle(50+j*xWaarde,yWaardeOnder,50+(j+1)*xWaarde,yWaardeOnder+10,Zwart,TRUE);
			END;(*IF x*)
		END; (*FOR j*)	
	END;(*IF y*)
	(*Knop om Tune te verlaten aanduiden*)
	IF   (y >= y1WaardeDone) AND (y <= y2WaardeDone) AND (x > x1WaardeDone)  AND (x < x2WaardeDone)
	THEN Omlijn(x1WaardeDone,y1WaardeDone,x2WaardeDone,y2WaardeDone,5,Zwart);
			Rectangle(0,yWaardeOnder,SCREEN_SIZE_X,yWaardeOnder+10,Wit,TRUE);
		 	Rectangle(hx,hy,hx+5,hy2,Wit,TRUE);
	END; (*IF y*)
	IF (y>hy) AND (x<hx)
    THEN Rectangle(hx,hy,hx+5,hy2,Zwart,TRUE);
		 Omlijn(x1WaardeDone,y1WaardeDone,x2WaardeDone,y2WaardeDone,5,Wit);
		 Rectangle(0,yWaardeOnder,SCREEN_SIZE_X,yWaardeOnder+10,Wit,TRUE);
	END; (*IF y and x*)
	
	RawOutText(xWaarde-40,yWaardeBoven-25,_clrBLACK,"Motor");
	RawOutText(xWaarde+85,yWaardeBoven-25,_clrBLACK,"Tankinhoud");
	RawOutText(xWaarde+215,yWaardeBoven-25,_clrBLACK,"Versnellingsbak");
	RawOutText(xWaarde+400,yWaardeBoven-25,_clrBLACK,"Remmen");
	
	IF MousePosition.left_pressed  THEN
    	IF (y > yWaardeBoven) AND (y < yWaardeOnder)
		THEN FOR j:=0 TO 3 DO
			 IF (x>50+j*xWaarde) AND (x<(50+(j+1)*xWaarde))
			 THEN
			 	CASE j OF
				 0: ControleAankoop(Gamer.GekozenAuto.Upgrade.Motor,j*xWaarde,yWaardeOnder+20);
				|1: ControleAankoop(Gamer.GekozenAuto.Upgrade.Tankinhoud,j*xWaarde,yWaardeOnder+20);
				|2: ControleAankoop(Gamer.GekozenAuto.Upgrade.Versnellingsbak,j*xWaarde,yWaardeOnder+20);
				|3: ControleAankoop(Gamer.GekozenAuto.Upgrade.Remmen,j*xWaarde,yWaardeOnder+20);
				END;(*Case*)
			 END; (*IF x*)
			 END; (*FOR j*)
		ELSIF (y >= y1WaardeDone) AND (y <= y2WaardeDone) AND (x > x1WaardeDone)  AND (x < x2WaardeDone)
		THEN  Bln:=TRUE;
		ELSIF (y>hy) AND (x<hx)
		THEN  Open:=Help(Open,'Tune',2,hx+10,hy,SCREEN_SIZE_X-hx,SCREEN_SIZE_Y);
		END; (*IFy *)	
	END; (*IF mouseposition*)
	END; (*WHILE*)  *)
END Tune;
(*---------------------------------------------------------------*)
PROCEDURE Save;
VAR
SpelersFile,AutoFile:FIO.File;
SportAutoFileLoc,FerrariFileLoc,VrachtwagenFileLoc,LegeLijn:ARRAY[1..50] OF CHAR;


BEGIN
SetUpdateMode(FALSE);
DrawSavedBitmap(0,0,ID10);
Update();
SetUpdateMode(TRUE);

Concat(SportAutoFileLoc,sloc,'SportAuto.txt');
AutoFile:=FIO.Open(SportAutoFileLoc);
FIO.WrStr(AutoFile,LegeLijn);
FIO.Close(AutoFile);
AutoFile:=FIO.Open(SportAutoFileLoc);
FIO.WrCard(AutoFile,VAL(CARDINAL, SportAuto.MaxSnelheid),4);
FIO.WrChar(AutoFile,' ');
FIO.WrCard(AutoFile,VAL(CARDINAL, SportAuto.OptrekSnelheid*100.0),4);
FIO.WrChar(AutoFile,' ');
FIO.WrCard(AutoFile,VAL(CARDINAL, SportAuto.RemSnelheid*10.0),4);
FIO.WrChar(AutoFile,' ');
FIO.WrCard(AutoFile,SportAuto.MaxBrandstof,4);
FIO.Close(AutoFile);


Concat(FerrariFileLoc,sloc,'Ferrari.txt');
AutoFile:=FIO.Open(FerrariFileLoc);
FIO.WrStr(AutoFile,LegeLijn);
FIO.Close(AutoFile);
AutoFile:=FIO.Open(FerrariFileLoc);
FIO.WrCard(AutoFile,VAL(CARDINAL, Ferari.MaxSnelheid),4);
FIO.WrChar(AutoFile,' ');
FIO.WrCard(AutoFile,VAL(CARDINAL, Ferari.OptrekSnelheid*100.0),4);
FIO.WrChar(AutoFile,' ');
FIO.WrCard(AutoFile,VAL(CARDINAL, Ferari.RemSnelheid*10.0),4);
FIO.WrChar(AutoFile,' ');
FIO.WrCard(AutoFile,Ferari.MaxBrandstof,4);
FIO.Close(AutoFile);


Concat(VrachtwagenFileLoc,sloc,'Vrachtwagen.txt');
AutoFile:=FIO.Open(VrachtwagenFileLoc);
FIO.WrStr(AutoFile,LegeLijn);
FIO.Close(AutoFile);
AutoFile:=FIO.Open(VrachtwagenFileLoc);
FIO.WrCard(AutoFile,VAL(CARDINAL, Vrachtwagen.MaxSnelheid),4);
FIO.WrChar(AutoFile,' ');
FIO.WrCard(AutoFile,VAL(CARDINAL, Vrachtwagen.OptrekSnelheid*100.0),4);
FIO.WrChar(AutoFile,' ');
FIO.WrCard(AutoFile,VAL(CARDINAL, Vrachtwagen.RemSnelheid*10.0),4);
FIO.WrChar(AutoFile,' ');
FIO.WrCard(AutoFile,Vrachtwagen.MaxBrandstof,4);
FIO.Close(AutoFile);


SpelersFile:=FIO.Open(loc);
FIO.WrStr(SpelersFile,LegeLijn);
FIO.Close(SpelersFile);
SpelersFile:=FIO.Open(loc);
FIO.WrStr(SpelersFile,Gamer.naam);
FIO.WrCard(SpelersFile,Gamer.Track,4);
FIO.WrCard(SpelersFile,Gamer.MaxTrack,4);
FIO.WrCard(SpelersFile,Gamer.GekozenAutoNr,4);
FIO.WrCard(SpelersFile,Gamer.MaxAuto,4);
FIO.WrCard(SpelersFile,Gamer.VerzameldePunten,4);
FIO.Close(SpelersFile);

WrStr("YES");

END Save;
(*---------------------------------------------------------------*)
PROCEDURE Score;
VAR  ScoreFile:FIO.File;
	 Arr: ARRAY [1..10] OF CARDINAL;
	 Scorenaam: ARRAY [1..12] OF CHAR;
	 i,p:CARDINAL ;
	 a:CHAR;
BEGIN
SetUpdateMode(FALSE);
DrawSavedBitmap(0,0,ID7);
Update();
SetUpdateMode(TRUE);
ScoreFile:=FIO.Open('TopscoreN.txt');
	FOR p:=1 TO 10 DO                           (*Zoek de fout*)
	FIO.RdStr(ScoreFile,Scorenaam);
	RawOutText((SCREEN_SIZE_X/2)+10,(250+(10*p)),Zwart,Scorenaam);
	END;(*For p*)
FIO.Close(ScoreFile);
ScoreFile:=FIO.Open('Topscores.txt');
	FOR i:=1 TO 10 DO
	Arr[i]:=FIO.RdCard(ScoreFile);
	DrawNumber(((SCREEN_SIZE_X/2)-10),(250+(20*i)),Arr[i],Zwart,Wit);
	WrCard(Arr[i],0);
	WrLn;
	END; (*For i*)
FIO.Close(ScoreFile);
a:=RdKey();

END Score;
(*---------------------------------------------------------------*)
PROCEDURE Load;
BEGIN
SetUpdateMode(FALSE);
DrawSavedBitmap(0,0,ID11);
Update();
SetUpdateMode(TRUE);
InladenGegevens;
END Load;
(*---------------------------------------------------------------*)
PROCEDURE Home;
VAR     m: CARDINAL;
 	Open: BOOLEAN;
	MousePosition: MsData;
BEGIN
(*b2:=InitSound(TRUE);
Delay(1000);
PlaySoundEvent(Intro); *)
SetUpdateMode(FALSE);
DrawSavedBitmap(0,0,ID1);
DrawSavedBitmap(SCREEN_SIZE_X-hx,hy,ID13);
Update();
SetUpdateMode(TRUE);
b:=FALSE;
Open:=FALSE;
RawOutText(520,20,Zwart,'In Game: ');
RawOutText(585,20,Zwart,Gamer.naam);
WHILE b=FALSE DO
Delay(50);
GetStatus(MousePosition);
x:=MousePosition.col;
y:=MousePosition.row;

IF   (y>f1) AND (y<f2)
THEN Rectangle(0,f2,700,f2+5,Wit,TRUE);
     Rectangle(0,f4,700,f4+5,Wit,TRUE);
     Rectangle(hx,hy,hx+5,hy2,Wit,TRUE);
	 Omlijn(SCREEN_SIZE_X-hx,hy,SCREEN_SIZE_X-10,SCREEN_SIZE_X-10,5,Wit);
	FOR m:=0 TO 3 DO
		IF (x>=(g1*m)) AND (x<(g1*(m+1)))
		THEN Rectangle(g1*m,f2,g1*(m+1),f2+5,Zwart,TRUE);
		END; (*IF x.....*)
	END; (*FOR m*)
END; (*IF*)

IF (y>f3) AND (y<f4)
THEN Rectangle(0,f4,700,f4+5,Wit,TRUE);
     Rectangle(0,f2,700,f2+5,Wit,TRUE);
     Rectangle(hx,hy,hx+5,hy2,Wit,TRUE);
	 Omlijn(SCREEN_SIZE_X-hx,hy,SCREEN_SIZE_X-10,SCREEN_SIZE_X-10,5,Wit);
	FOR m:=0 TO 2 DO
		IF   (x>=(g1*m+g2)) AND (x<=(g1*(m+1)+g2))
		THEN Rectangle(g1*m+g2,f4,(g1*(m+1)+g2),f4+5,Zwart,TRUE);
		END; (*IF x......*)
	END; (*FOR m*)
END; (*IF*)

IF (y>hy) AND (x<hx)
THEN Rectangle(hx,hy,hx+5,hy2,Zwart,TRUE);
     Rectangle(0,f4,700,f4+5,Wit,TRUE);
     Rectangle(0,f2,700,f2+5,Wit,TRUE);
	 Omlijn(SCREEN_SIZE_X-hx,hy,SCREEN_SIZE_X-10,SCREEN_SIZE_X-10,5,Wit);
END; (*IF*)

(*--Exit Button--*)
IF (y>(hy)) AND (x>(SCREEN_SIZE_X-hx))
THEN Rectangle(hx,hy,hx+5,hy2,Wit,TRUE);
     Rectangle(0,f4,700,f4+5,Wit,TRUE);
     Rectangle(0,f2,700,f2+5,Wit,TRUE);
	 Omlijn(SCREEN_SIZE_X-hx,hy,SCREEN_SIZE_X-10,SCREEN_SIZE_X-10,5,Zwart);
END; (*Exit Button*)

IF MousePosition.left_pressed  THEN
	WrStr('Klik!');
	IF (y>f1) AND (y<f2)  THEN
		FOR m := 0 TO 3 DO
			IF (x>(g1*m)) AND (x<(g1*(m+1)))
			THEN
			CASE m OF
			 0: b:=TRUE; Rc; Home;
			|1: b:=TRUE; CarSlct;Home;
			|2: b:=TRUE; Track;Home;
			|3: b:=TRUE; Tune;Home;
			END; (*CASE*)
			END;(*IF x....*)
		END; (*for m*)	
	ELSIF (y>f3) AND (y<f4)
	THEN
		FOR m:=0 TO 2 DO
			IF (x>(g1*m+g2)) AND (x<(g1*(m+1)+g2)) THEN
			CASE m OF
			 0: b:=TRUE;  Save;Home;
			|1: b:=TRUE;  Score; Home;
			|2: b:=TRUE;  Load;Home;			
			END; (*CASE*)
			END; (*IF x....*)
		END; (*FOR m*)	
	ELSIF (y>hy) AND (x<hx)
	THEN  Open:=Help(Open,'Home',2,(hx+10),hy,(SCREEN_SIZE_X-hx),SCREEN_SIZE_Y);
	ELSIF (y>(hy)) AND (x>(SCREEN_SIZE_X-hx))
	THEN  b:=TRUE;
	
	END; (*IF y*)
END; (*IF mouse....left.pressed*)
END; (*While b*)

END Home;

BEGIN
 IF NOT Init(1,1,SCREEN_SIZE_X,SCREEN_SIZE_Y)THEN WrStr("No mouse!");WrLn;
 RETURN;
 END;
 InitMouse();
 LaadAfbeeldingenIn;
 ID9:=SetBkColor(Wit);
 Launch;
 Home;

END Home.